// This include brings in a definition for fortran_routine() so that it
// can be called from C++
#include "fortran_routines.h"
// cpp_variables.h has a definition of the structure variables, and
// links it to the equivalent fortran common block vari_ (or vari_)
#include "cpp_variables.h"
// Should look at cpp_variables.h and fortran_variables.h to see how
// this stuff is changed, along with what works and doesn't work.

#include <iostream.h>

int main() 
{ 
	int i, j, k;
	
	cout<<" start in C++ "<<endl<<endl;

	// set variables in Fortran, and print them (all done from C++)
    cout<<"Setting variables in Fortran, via C++, and printing from C++"<<endl;
	vari_.value_bool = true; cout<<vari_.value_bool<<endl;
	vari_.value_int = 12345; cout<<vari_.value_int<<endl;
	vari_.value_float = 1.23; cout<<vari_.value_float<<endl;
	vari_.value_double = 5.67; cout<<vari_.value_double<<endl;
	for( i=0; i<5; i++){
		vari_.value_vector[i] = i; 
		cout<<"\t"<<i<<"\t"<<vari_.value_vector[i]<<endl;
	}
	for( i=0; i<2; i++){
		for( j=0; j<4; j++){
			vari_.value_matrix[j][i] = i*4 + j;
			cout<<"\t"<<i<<"  "<<j<<"\t"<<vari_.value_matrix[j][i]<<endl;
		}
    }
		
	fortran_routine__(); // This calls fortran_routine() from fortran_routines.f
    
    // Printing here from C++ (the fortran code changes the values after
    // it prints the C++Set versions so this is a test:
	cout<<" back in C++ "<<endl<<endl;
	cout<<"Try to print info from C++ side of the house"<<endl;
	cout<< "variables ---------------------"<<endl;
    cout<<"boolean value "<<vari_.value_bool<<endl;
    cout<<"int value "<<vari_.value_int<<endl;
    cout<<"real value "<<vari_.value_float<<endl;
    cout<<"real*8 value "<<vari_.value_double<<endl;
    cout<<"vector"<<endl;
	for (i=0; i<5; i++){
		cout<<"\t"<<i<<"\t"<<vari_.value_vector[i]<<endl;
	}
    cout<<"matrix\n";
	for (i=0; i<2; i++){
		for (j=0; j<4; ++j){
			cout<<"\t"<<i<<"  "<<j<<"\t"<<vari_.value_matrix[j][i]<<endl;
		}
	}
	return 0;
}
